diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index 920ca6120..8a7d9fa9f 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -36,7 +36,11 @@ import net.minecraft.core.entity.projectile.ProjectileCannonball;
 import net.minecraft.core.entity.projectile.ProjectileFireball;
 import net.minecraft.core.entity.projectile.ProjectileArrowGolden;
 import net.minecraft.core.entity.vehicle.EntityBoat;
-import net.minecraft.core.entity.vehicle.MinecartEntity;
+import net.minecraft.core.entity.vehicle.EntityMinecart;
+import net.minecraft.core.enums.ArtType;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.enums.EnumSleepStatus;
+import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
@@ -67,7 +71,9 @@ import java.util.Comparator;
 import java.util.List;
 import java.util.UUID;
 
-public abstract class Player extends Mob implements IArmorWearing<HumanArmorShape>
+public abstract class Player
+    extends Mob
+    implements IArmorWearing<HumanArmorShape>, IItemHolding
 {
     public static final int DATA_UNKNOWN = 16; // I have no idea wtf this id is for
     public static final int DATA_SELECTED_ART = 17;
@@ -119,6 +125,8 @@ public abstract class Player extends Mob implements IArmorWearing<HumanArmorShap
     public int lastRenderTick = 0;
     public float wobbleTimer = 0;
 
+    public final PlayerConfig playerConfig = new PlayerConfig();
+
     public Player(World world)
     {
         super(world);
@@ -986,27 +994,27 @@ public abstract class Player extends Mob implements IArmorWearing<HumanArmorShap
         }
     }
     
-    public void displayFurnaceScreen(TileEntityFurnace blockEntity)
+    public void displayFurnaceScreen(TileEntityFurnace tileEntity)
     {
     }
 
-    public void displayTrommelScreen(TileEntityTrommel blockEntity)
+    public void displayTrommelScreen(TileEntityTrommel tileEntity)
     {
     }
 
-    public void displayDispenserScreen(TileEntityDispenser blockEntity)
+    public void displayDispenserScreen(TileEntityDispenser tileEntity)
     {
     }
 
-    public void displayActivatorScreen(TileEntityActivator blockEntity)
+    public void displayActivatorScreen(TileEntityActivator tileEntity)
     {
     }
 
-    public void displaySignEditorScreen(TileEntitySign blockEntity)
+    public void displaySignEditorScreen(TileEntitySign tileEntity)
     {
     }
 
-    public void displayFlagEditorScreen(TileEntityFlag blockEntity)
+    public void displayFlagEditorScreen(TileEntityFlag tileEntity)
     {
     }
 
@@ -1326,7 +1334,17 @@ public abstract class Player extends Mob implements IArmorWearing<HumanArmorShap
     {
         return inventory.getCurrentItem();
     }
-    
+
+    @Override
+    public boolean isLeftHanded() {
+        return playerConfig.isLeftHand();
+    }
+
+    @Override
+    public void setHeldItem(@Nullable ItemStack item) {
+        inventory.setCurrentItem(item, true);
+    }
+
     public void updateCreativeInventory(int page, String searchText)
     {
     }
@@ -1434,7 +1452,7 @@ public abstract class Player extends Mob implements IArmorWearing<HumanArmorShap
             int i = java.lang.Math.round(MathHelper.sqrt(d * d + d1 * d1 + d2 * d2) * 100F);
             if(i > 0)
             {
-                if(vehicle instanceof MinecartEntity)
+                if(vehicle instanceof EntityMinecart)
                 {
                     addStat(StatList.distanceByMinecartStat, i);
                     if(startMinecartRidingCoordinate == null)
@@ -1553,7 +1571,7 @@ public abstract class Player extends Mob implements IArmorWearing<HumanArmorShap
     		return;
     	}
     	
-    	TileEntity tileEntity = world.getBlockEntity(x, y, z);
+    	TileEntity tileEntity = world.getTileEntity(x, y, z);
     	ItemStack[] result = block.getBreakResult(world, EnumDropCause.PICK_BLOCK, x, y, z, meta, tileEntity);
     	ItemStack selectItem = result != null ? result[0] : null;
     	
@@ -1693,4 +1711,32 @@ public abstract class Player extends Mob implements IArmorWearing<HumanArmorShap
             return o1.username.compareTo(o2.username);
         }
     }
+
+    public static class PlayerConfig {
+        public static final int MASK_LEFT_HAND = 0b0000_0001;
+
+        public PlayerConfigListener listener;
+        public byte config = 0;
+
+        public void assignListener(PlayerConfigListener listener) {
+            this.listener = listener;
+        }
+
+        public boolean isLeftHand() {
+            return (config & MASK_LEFT_HAND) != 0;
+        }
+
+        public void setLeftHand(boolean leftHand) {
+            if (leftHand) {
+                config |= MASK_LEFT_HAND;
+            } else {
+                config &= ~MASK_LEFT_HAND;
+            }
+            if (listener != null) listener.onValueChange();
+        }
+
+        public interface PlayerConfigListener {
+            void onValueChange();
+        }
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
similarity index 90%
rename from game/core/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
rename to game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
index 1efb9fef0..ed17b7bc4 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
@@ -27,13 +27,18 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.List;
 
-public class MinecartEntity extends Entity implements Container {
-    public static final int PASSENGER_CART = 0;
-    public static final int CHEST_CART = 1;
-    public static final int FURNACE_CART = 2;
+public class EntityMinecart extends Entity implements Container {
+    public static final byte PASSENGER_CART = 0;
+    public static final byte CHEST_CART = 1;
+    public static final byte FURNACE_CART = 2;
 
     public static final int TYPE_MASK_COLOR = 0b1111_0000;
     public static final int TYPE_MASK_PAINTED_CHEST = 0b0000_0001;
+
+    public static final int FLAG_TYPE = 10;
+    public static final int FLAG_META = 11;
+    public static final int FLAG_FUEL = 12;
+
     // 10 x 2 x 3 table of something
     private static final int[][][] EXITS = {
         {
@@ -82,9 +87,6 @@ public class MinecartEntity extends Entity implements Container {
     public int timeSinceHit;
     public int hurtDirection;
     public boolean flipped;
-    public int type;
-    public int typeMeta; // Just used for chest color *for now*
-    public int fuel;
     public double xPush;
     public double zPush;
     private int lerpTicks;
@@ -98,7 +100,7 @@ public class MinecartEntity extends Entity implements Container {
     private double lerpZD;
 
 
-    public MinecartEntity(World world) {
+    public EntityMinecart(World world) {
         super(world);
         items = new ItemStack[36];
         currentDamage = 0;
@@ -109,7 +111,7 @@ public class MinecartEntity extends Entity implements Container {
         setSize(0.98F, 0.7F);
         heightOffset = bbHeight / 2.0F;
     }
-    public MinecartEntity(World world, double x, double y, double z, int type) {
+    public EntityMinecart(World world, double x, double y, double z, int type) {
         this(world);
         setPos(x, y + (double) heightOffset, z);
         xd = 0.0D;
@@ -118,7 +120,7 @@ public class MinecartEntity extends Entity implements Container {
         xo = x;
         yo = y;
         zo = z;
-        this.type = type;
+        setType((byte) type);
     }
     @Override
     public float getShadowHeightOffs() {
@@ -130,7 +132,21 @@ public class MinecartEntity extends Entity implements Container {
     }
     @Override
 	protected void defineSynchedData() {
+        entityData.define(FLAG_TYPE, (byte)0, Byte.class);
+        entityData.define(FLAG_META, 0, Integer.class);
+        entityData.define(FLAG_FUEL, (short)0, Short.class);
     }
+
+    public void setType(byte type) {entityData.set(FLAG_TYPE, type);}
+    public byte getType() {return entityData.getByte(FLAG_TYPE);}
+
+    public void setMeta(int meta) {entityData.set(FLAG_META, meta);}
+    public int getMeta() {return entityData.getInt(FLAG_META);}
+
+    public void setFuel(int fuel) {entityData.set(FLAG_FUEL, fuel);}
+    public short getFuel() {return entityData.getShort(FLAG_FUEL);}
+
+
     @Override
 	public boolean isPushable() {
         return true;
@@ -196,10 +212,10 @@ public class MinecartEntity extends Entity implements Container {
             }
             if (!world.isClientSide){
                 dropItem(Items.MINECART.id, 1, 0.0F);
-                switch (this.type){
+                switch (getType()){
                     case CHEST_CART:
-                        if ((typeMeta & TYPE_MASK_PAINTED_CHEST) != 0) {
-                            dropItem(new ItemStack(Blocks.CHEST_PLANKS_OAK_PAINTED, 1, typeMeta & TYPE_MASK_COLOR), 0.0F);
+                        if ((getMeta() & TYPE_MASK_PAINTED_CHEST) != 0) {
+                            dropItem(new ItemStack(Blocks.CHEST_PLANKS_OAK_PAINTED, 1, getMeta() & TYPE_MASK_COLOR), 0.0F);
                         } else {
                             dropItem(Blocks.CHEST_PLANKS_OAK.id(), 1, 0.0F);
                         }
@@ -393,7 +409,7 @@ public class MinecartEntity extends Entity implements Container {
                 yd *= 0.0D;
                 zd *= 0.997D;
             } else {
-                if(type == FURNACE_CART) {
+                if(getType() == FURNACE_CART) {
                     vel = Math.hypot(xPush, zPush);
                     if(vel > 0.01D) {
                         didFurnacePush = true;
@@ -432,7 +448,7 @@ public class MinecartEntity extends Entity implements Container {
                 xd = vel * (double)(newBlockX - blockX);
                 zd = vel * (double)(newBlockZ - blockZ);
             }
-            if(type == FURNACE_CART) {
+            if(getType() == FURNACE_CART) {
                 double pushMagnitude = Math.hypot(xPush, zPush);
                 if(pushMagnitude > 0.01D && Math.hypot(xd, zd) > 0.001D) {
                     xPush = xd;
@@ -497,7 +513,7 @@ public class MinecartEntity extends Entity implements Container {
         List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.expand(0.2D, 0.0D, 0.2));
         if(list != null && !list.isEmpty()) {
             for (Entity entity : list) {
-                if ((entity instanceof MinecartEntity) && entity != passenger && entity.isPushable()) {
+                if ((entity instanceof EntityMinecart) && entity != passenger && entity.isPushable()) {
                     entity.push(this);
                 }
             }
@@ -506,8 +522,8 @@ public class MinecartEntity extends Entity implements Container {
             passenger = null;
         }
         if(didFurnacePush && random.nextInt(4) == 0) {
-            fuel--;
-            if(fuel < 0) {
+            setFuel(getFuel() - 1);
+            if(getFuel() < 0) {
                 xPush = 0.0D;
                 zPush = 0.0D;
             }
@@ -636,7 +652,7 @@ public class MinecartEntity extends Entity implements Container {
         if(!entity.isPushable()) {
         	return;
         }
-        if(type == PASSENGER_CART && (entity instanceof Mob) && !(entity instanceof Player) && xd * xd + zd * zd > 0.01D && passenger == null && entity.vehicle == null) {
+        if(getType() == PASSENGER_CART && (entity instanceof Mob) && !(entity instanceof Player) && xd * xd + zd * zd > 0.01D && passenger == null && entity.vehicle == null) {
             entity.startRiding(this);
         }
         final double diffX = entity.x - this.x;
@@ -658,15 +674,17 @@ public class MinecartEntity extends Entity implements Container {
             final double n13 = n11 * (1.0f - this.pushthrough);
             final double xForce = n12 * 0.5;
             final double zForce = n13 * 0.5;
-            if (entity instanceof MinecartEntity) {
-                if (((MinecartEntity)entity).type == FURNACE_CART && this.type != FURNACE_CART) {
+            if (entity instanceof EntityMinecart) {
+                int thisType = getType();
+                int otherType = ((EntityMinecart) entity).getType();
+                if (otherType == FURNACE_CART && thisType != FURNACE_CART) {
                     this.xd *= 0.2;
                     this.zd *= 0.2;
                     this.push(entity.xd - xForce, 0.0, entity.zd - zForce);
                     entity.xd *= 0.7;
                     entity.zd *= 0.7;
                 }
-                else if (((MinecartEntity)entity).type != FURNACE_CART && this.type == FURNACE_CART) {
+                else if (otherType != FURNACE_CART && thisType == FURNACE_CART) {
                     entity.xd *= 0.2;
                     entity.zd *= 0.2;
                     entity.push(this.xd + xForce, 0.0, this.zd + zForce);
@@ -701,17 +719,17 @@ public class MinecartEntity extends Entity implements Container {
 
     @Override
 	public boolean interact(@NotNull Player player) {
-        switch (type){
+        switch (getType()){
             case PASSENGER_CART:
                 if (!world.isClientSide && passenger == null && player.isSneaking() && player.getHeldObject() instanceof CarriedBlock) {
                     CarriedBlock carriedBlock = (CarriedBlock) player.getHeldObject();
                     if (carriedBlock.entity instanceof TileEntityChest) {
                         TileEntityChest chest = (TileEntityChest) carriedBlock.entity;
-                        this.type = CHEST_CART;
+                        setType(CHEST_CART);
                         if (carriedBlock.blockId == Blocks.CHEST_PLANKS_OAK_PAINTED.id()) {
-                            this.typeMeta = carriedBlock.metadata & TYPE_MASK_COLOR | TYPE_MASK_PAINTED_CHEST;
+                            setMeta(carriedBlock.metadata & TYPE_MASK_COLOR | TYPE_MASK_PAINTED_CHEST);
                         } else {
-                            this.typeMeta = carriedBlock.metadata & TYPE_MASK_COLOR;
+                            setMeta(carriedBlock.metadata & TYPE_MASK_COLOR);
                         }
                         for (int i = 0; i < this.getContainerSize(); i++) {
                             this.setItem(i, chest.getItem(i));
@@ -731,22 +749,22 @@ public class MinecartEntity extends Entity implements Container {
             case CHEST_CART:
                 if(!world.isClientSide) {
                     if (player.isSneaking() && player.inventory.getCurrentItem() == null && player.getHeldObject() == null) {
-                        TileEntityChest blockEntity = new TileEntityChest();
+                        TileEntityChest tileEntityChest = new TileEntityChest();
                         for (int i = 0; i < this.getContainerSize(); i++) {
-                            blockEntity.setItem(i, this.getItem(i));
+                            tileEntityChest.setItem(i, this.getItem(i));
                             this.setItem(i, null);
                         }
-                        blockEntity.worldObj = null;
+                        tileEntityChest.worldObj = null;
                         Block<?> block;
-                        if ((typeMeta & TYPE_MASK_PAINTED_CHEST) != 0) {
+                        if ((getMeta() & TYPE_MASK_PAINTED_CHEST) != 0) {
                             block = Blocks.CHEST_PLANKS_OAK_PAINTED;
                         } else {
                             block = Blocks.CHEST_PLANKS_OAK;
                         }
-                        blockEntity.carriedBlock = blockEntity.getCarriedEntry(world, player, block, typeMeta & TYPE_MASK_COLOR);
-                        player.setHeldObject(blockEntity.carriedBlock);
-                        this.type = PASSENGER_CART;
-                        this.typeMeta = 0;
+                        tileEntityChest.carriedBlock = tileEntityChest.getCarriedEntry(world, player, block, getMeta() & TYPE_MASK_COLOR);
+                        player.setHeldObject(tileEntityChest.carriedBlock);
+                        setType(PASSENGER_CART);
+                        setMeta(0);
                     } else {
                         player.displayContainerScreen(this);
                     }
@@ -759,7 +777,7 @@ public class MinecartEntity extends Entity implements Container {
                     {
                         player.inventory.setItem(player.inventory.getCurrentItemIndex(), null);
                     }
-                    fuel += (int) ((LookupFuelFurnace.instance.getFuelYield(itemstack.itemID)/1600F) * 1200);
+                    setFuel(getFuel() + (int) ((LookupFuelFurnace.instance.getFuelYield(itemstack.itemID)/1600F) * 1200));
                 }
                 xPush = x - player.x;
                 zPush = z - player.z;
@@ -770,9 +788,9 @@ public class MinecartEntity extends Entity implements Container {
 
     @Override
     public void addAdditionalSaveData(@NotNull CompoundTag tag) {
-        tag.putInt("Type", type);
-        tag.putInt("TypeMeta", typeMeta);
-        switch (type){
+        tag.putInt("Type", getType());
+        tag.putInt("TypeMeta", getMeta());
+        switch (getType()){
             case CHEST_CART:
                 ListTag nbttaglist = new ListTag();
                 for(int i = 0; i < items.length; i++) {
@@ -788,16 +806,16 @@ public class MinecartEntity extends Entity implements Container {
             case FURNACE_CART:
                 tag.putDouble("PushX", xPush);
                 tag.putDouble("PushZ", zPush);
-                tag.putShort("Fuel", (short)fuel);
+                tag.putShort("Fuel", (short)getFuel());
                 break;
         }
     }
 
     @Override
     public void readAdditionalSaveData(@NotNull CompoundTag tag) {
-        type = tag.getInteger("Type");
-        typeMeta = tag.getInteger("TypeMeta");
-        switch (type){
+        setType((byte) tag.getInteger("Type"));
+        setMeta(tag.getInteger("TypeMeta"));
+        switch (getType()){
             case CHEST_CART:
                 ListTag nbttaglist = tag.getList("Items");
                 items = new ItemStack[getContainerSize()];
@@ -812,7 +830,7 @@ public class MinecartEntity extends Entity implements Container {
             case FURNACE_CART:
                 xPush = tag.getDouble("PushX");
                 zPush = tag.getDouble("PushZ");
-                fuel = tag.getShort("Fuel");
+                setFuel(tag.getShort("Fuel"));
                 break;
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/Item.java b/game/core/src/main/java/net/minecraft/core/item/Item.java
index 94f88a14f..8983d06d8 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Item.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Item.java
@@ -297,7 +297,7 @@ public class Item implements ITaggable<Item>, IItemConvertible
 
     public String getStatName()
     {
-        return I18n.getInstance().translateNameKey(getKey());
+        return I18n.getInstance().translateKey(getKey() + ".name");
     }
 
     public void inventoryTick(ItemStack itemstack, World world, Entity entity, int i, boolean flag)
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
index 175a52360..f28d368c0 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
@@ -42,7 +42,7 @@ public class ItemDye extends Item
     {
         if (world.getBlockId(blockX, blockY, blockZ) == Blocks.SIGN_POST_PLANKS_OAK.id() || world.getBlockId(blockX, blockY, blockZ) == Blocks.SIGN_WALL_PLANKS_OAK.id())
         {
-            TileEntitySign sign = (TileEntitySign) world.getBlockEntity(blockX, blockY, blockZ);
+            TileEntitySign sign = (TileEntitySign) world.getTileEntity(blockX, blockY, blockZ);
             if ((DyeColor.WHITE.itemMeta - itemstack.getMetadata()) != sign.getColor().id)
             {
                 sign.setColor(TextFormatting.get(DyeColor.WHITE.itemMeta - itemstack.getMetadata()));
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java b/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
index 325383700..7be3d76fe 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
@@ -33,7 +33,7 @@ public class ItemFlag extends Item
     {
         // copy flag data to empty flag
 		if (world.getBlockId(blockX, blockY, blockZ) == Blocks.FLAG.id() && !entityplayer.isSneaking()) {
-			TileEntityFlag flag = (TileEntityFlag) world.getBlockEntity(blockX, blockY, blockZ);
+			TileEntityFlag flag = (TileEntityFlag) world.getTileEntity(blockX, blockY, blockZ);
 			if (flag != null) {
 				CompoundTag flagData = stack.getData().getCompoundOrDefault("FlagData", new CompoundTag());
 				if (hasFlagBeenDrawnOn(stack) && doesFlagContainDyes(stack)) {
@@ -74,7 +74,7 @@ public class ItemFlag extends Item
         world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.FLAG.id(), 0);
         
         stack.consumeItem(entityplayer);
-        TileEntityFlag tileEntityFlag = (TileEntityFlag) world.getBlockEntity(blockX, blockY, blockZ);
+        TileEntityFlag tileEntityFlag = (TileEntityFlag) world.getTileEntity(blockX, blockY, blockZ);
         if(tileEntityFlag != null)
         {
             CompoundTag flagData = stack.getData().getCompoundOrDefault("FlagData", null);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemMap.java b/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
index c9ccc12be..5a78c5cc2 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
@@ -123,7 +123,7 @@ public class ItemMap extends Item implements IComplexItem
 		if (world.getBlockId(blockX, blockY, blockZ) == Blocks.FLAG.id()) {
 			ItemMapSavedData mapData = getOrCreateSavedData(itemstack, world);
 			if (mapData != null){
-				TileEntityFlag flag = (TileEntityFlag) world.getBlockEntity(blockX, blockY, blockZ);
+				TileEntityFlag flag = (TileEntityFlag) world.getTileEntity(blockX, blockY, blockZ);
 				boolean canCreateMap = mapData.createNewWaypoint(flag);
 				if(!canCreateMap)
 					player.sendTranslatedChatMessage("flag.full");
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java b/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
index 83e29e168..48656bc64 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
@@ -6,7 +6,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicRail;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.entity.vehicle.MinecartEntity;
+import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
@@ -28,7 +28,7 @@ public class ItemMinecart extends Item {
         if (!Block.hasLogicClass(block, BlockLogicRail.class)) { return false; }
 
         if(!world.isClientSide) {
-            world.entityJoinedWorld(new MinecartEntity(world, (float) blockX + 0.5F, (float) blockY + 0.5F, (float) blockZ + 0.5F, minecartType));
+            world.entityJoinedWorld(new EntityMinecart(world, (float) blockX + 0.5F, (float) blockY + 0.5F, (float) blockZ + 0.5F, minecartType));
         }
         if (player == null || player.getGamemode().consumeBlocks()) {
             itemstack.stackSize--;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSign.java b/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
index d092dd03b..d8b017b82 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
@@ -52,7 +52,7 @@ public class ItemSign extends Item
             world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.SIGN_WALL_PLANKS_OAK.id(), sideHit);
         }
         itemstack.consumeItem(entityplayer);
-        TileEntitySign tileentitysign = (TileEntitySign)world.getBlockEntity(blockX, blockY, blockZ);
+        TileEntitySign tileentitysign = (TileEntitySign)world.getTileEntity(blockX, blockY, blockZ);
         if(tileentitysign != null)
         {
             tileentitysign.setOwner(entityplayer);
diff --git a/game/core/src/main/java/net/minecraft/core/item/Items.java b/game/core/src/main/java/net/minecraft/core/item/Items.java
index 4160f000e..291861c4a 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Items.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Items.java
@@ -3,7 +3,7 @@ package net.minecraft.core.item;
 import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.entity.vehicle.MinecartEntity;
+import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.item.material.ToolMaterial;
@@ -195,7 +195,12 @@ public final class Items {
     public static Item JAR_BUTTERFLY_PINK;
     public static Item JAR_BUTTERFLY_SILVER;
     public static Item STATUE_STONE;
-    
+    public static Item STATUE_BASALT;
+    public static Item STATUE_LIMESTONE;
+    public static Item STATUE_GRANITE;
+    public static Item STATUE_MARBLE;
+    public static Item STATUE_PIGMAN;
+
     private static boolean hasInit = false;
     public static void init(){
         if (hasInit) return;
@@ -308,7 +313,7 @@ public final class Items {
         BUCKET = (new ItemBucketEmpty("bucket", "minecraft:item/bucket", 16453));
         BUCKET_WATER = (new ItemBucket("bucket.water", "minecraft:item/bucket_water", 16454, Blocks.FLUID_WATER_FLOWING)).setContainerItem(BUCKET);
         BUCKET_LAVA = (new ItemBucket("bucket.lava", "minecraft:item/bucket_lava", 16455, Blocks.FLUID_LAVA_FLOWING)).setContainerItem(BUCKET);
-        MINECART = (new ItemMinecart("minecart", "minecraft:item/minecart", 16456, MinecartEntity.PASSENGER_CART));
+        MINECART = (new ItemMinecart("minecart", "minecraft:item/minecart", 16456, EntityMinecart.PASSENGER_CART));
         SADDLE = (new ItemSaddle("saddle", "minecraft:item/saddle", 16457));
         DOOR_IRON = (new ItemDoor("door.iron", "minecraft:item/door_iron", 16458, Blocks.DOOR_IRON_BOTTOM, Blocks.DOOR_IRON_TOP));
         DUST_REDSTONE = (new ItemPlaceable("dust.redstone", "minecraft:item/dust_redstone", 16459, Blocks.WIRE_REDSTONE));
@@ -322,8 +327,8 @@ public final class Items {
         PAPER = (new Item("paper", "minecraft:item/paper", 16467));
         BOOK = (new Item("book", "minecraft:item/book", 16468));
         SLIMEBALL = (new Item("slimeball", "minecraft:item/slimeball", 16469));
-        MINECART_CHEST = (new ItemMinecart("minecart.chest", "minecraft:item/minecart_chest", 16470, MinecartEntity.CHEST_CART));
-        MINECART_FURNACE = (new ItemMinecart("minecart.furnace", "minecraft:item/minecart_furnace", 16471, MinecartEntity.FURNACE_CART));
+        MINECART_CHEST = (new ItemMinecart("minecart.chest", "minecraft:item/minecart_chest", 16470, EntityMinecart.CHEST_CART));
+        MINECART_FURNACE = (new ItemMinecart("minecart.furnace", "minecraft:item/minecart_furnace", 16471, EntityMinecart.FURNACE_CART));
         EGG_CHICKEN = (new ItemEgg("egg.chicken", "minecraft:item/egg_chicken", 16472));
         TOOL_COMPASS = (new Item("tool.compass", "minecraft:item/tool_compass", 16473));
         TOOL_FISHINGROD = (new ItemFishingRod("tool.fishingrod", "minecraft:item/tool_fishingrod", 16474));
@@ -410,5 +415,10 @@ public final class Items {
         JAR_BUTTERFLY_PINK = new ItemPlaceable("jar.butterfly.pink", "minecraft:item/jar_butterfly_pink", 16541, Blocks.JAR_BUTTERFLY_PINK);
         JAR_BUTTERFLY_SILVER = new ItemPlaceable("jar.butterfly.silver", "minecraft:item/jar_butterfly_silver", 16542, Blocks.JAR_BUTTERFLY_SILVER);
         STATUE_STONE = new ItemStatue("statue.stone", "minecraft:item/statue_stone", 16543, Blocks.STATUE_STONE_LOWER, Blocks.STATUE_STONE_UPPER);
+        STATUE_BASALT = new ItemStatue("statue.basalt", "minecraft:item/statue_basalt", 16544, Blocks.STATUE_BASALT_LOWER, Blocks.STATUE_BASALT_UPPER);
+        STATUE_LIMESTONE = new ItemStatue("statue.limestone", "minecraft:item/statue_limestone", 16545, Blocks.STATUE_LIMESTONE_LOWER, Blocks.STATUE_LIMESTONE_UPPER);
+        STATUE_GRANITE = new ItemStatue("statue.granite", "minecraft:item/statue_granite", 16546, Blocks.STATUE_GRANITE_LOWER, Blocks.STATUE_GRANITE_UPPER);
+        STATUE_MARBLE = new ItemStatue("statue.marble", "minecraft:item/statue_marble", 16547, Blocks.STATUE_MARBLE_LOWER, Blocks.STATUE_MARBLE_UPPER);
+        STATUE_PIGMAN = new ItemStatue("statue.pigman", "minecraft:item/statue_pigman", 16548, Blocks.STATUE_PIGMAN_LOWER, Blocks.STATUE_PIGMAN_UPPER);
     }
 }
